<html>
<head>
<title>OgreD3D11GpuProgram.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a2df88393729a3f182c00116937c948.html">Direct3D11</a>      </li>
      <li class="navelem"><a class="el" href="dir_80c990f15d364d52e4690b415f060ae9.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D11GpuProgram.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D11GpuProgram_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D11GpuProgram_H_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D11GpuProgram_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D11Prerequisites_8h.html">OgreD3D11Prerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre {
<a name="l00036"></a>00036 
<a name="l00038"></a><a class="code" href="classOgre_1_1D3D11GpuProgram.html">00038</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D11GpuProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>
<a name="l00039"></a>00039     {
<a name="l00040"></a>00040     <span class="keyword">protected</span>:
<a name="l00041"></a><a class="code" href="classOgre_1_1D3D11GpuProgram.html#a66771fa2062b434683b59693bb4b813c">00041</a>         <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; <a class="code" href="classOgre_1_1D3D11GpuProgram.html#a66771fa2062b434683b59693bb4b813c">mDevice</a>;
<a name="l00042"></a>00042     <span class="keyword">public</span>:
<a name="l00043"></a>00043         <a class="code" href="classOgre_1_1D3D11GpuProgram.html#acc3d6b1ca56a57176e1172bc838b162c">D3D11GpuProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00044"></a>00044             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader, <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; device);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046     <span class="keyword">protected</span>:
<a name="l00048"></a>00048         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11GpuProgram.html#af3c47d32df43950611d00e037359f176">loadImpl</a>(<span class="keywordtype">void</span>);
<a name="l00050"></a>00050         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11GpuProgram.html#a4ccc9fcc8a05c1500454fa97ebc089c6" title="Overridden from GpuProgram.">loadFromSource</a>(<span class="keywordtype">void</span>);
<a name="l00052"></a>00052         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11GpuProgram.html#a690ff7e359c525a412fc6c0a1a7cbbd9" title="Internal method to load from microcode, must be overridden by subclasses.">loadFromMicrocode</a>(ID3D10Blob *  microcode) = 0;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055     };
<a name="l00056"></a>00056 
<a name="l00058"></a><a class="code" href="classOgre_1_1D3D11GpuVertexProgram.html">00058</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11GpuVertexProgram.html" title="Direct3D implementation of low-level vertex programs.">D3D11GpuVertexProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1D3D11GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D11GpuProgram</a>
<a name="l00059"></a>00059     {
<a name="l00060"></a>00060     <span class="keyword">protected</span>:
<a name="l00061"></a><a class="code" href="classOgre_1_1D3D11GpuVertexProgram.html#a0228dde32e80907ca70730205183140c">00061</a>         ID3D11VertexShader * <a class="code" href="classOgre_1_1D3D11GpuVertexProgram.html#a0228dde32e80907ca70730205183140c">mVertexShader</a>;
<a name="l00062"></a>00062     <span class="keyword">public</span>:
<a name="l00063"></a>00063         <a class="code" href="classOgre_1_1D3D11GpuVertexProgram.html#ae4de593c0f182de21d01f69edd59611f">D3D11GpuVertexProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00064"></a>00064             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader, <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; device);
<a name="l00065"></a>00065         <a class="code" href="classOgre_1_1D3D11GpuVertexProgram.html#a379ae8c64cce577e3d805497621388f2">~D3D11GpuVertexProgram</a>();
<a name="l00067"></a>00067         ID3D11VertexShader * <a class="code" href="classOgre_1_1D3D11GpuVertexProgram.html#aa333ed7b641cf8ac4d184cfa63cc24db" title="Gets the vertex shader.">getVertexShader</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00068"></a>00068     <span class="keyword">protected</span>:
<a name="l00070"></a>00070         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11GpuVertexProgram.html#a01ede5358536d1cecf2f288d8365dda4">unloadImpl</a>(<span class="keywordtype">void</span>);
<a name="l00071"></a>00071         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11GpuVertexProgram.html#a1a79a2be8c8c24d94ac84d684cef90ac" title="Internal method to load from microcode, must be overridden by subclasses.">loadFromMicrocode</a>(ID3D10Blob *  microcode);
<a name="l00072"></a>00072     };
<a name="l00073"></a>00073 
<a name="l00075"></a><a class="code" href="classOgre_1_1D3D11GpuFragmentProgram.html">00075</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11GpuFragmentProgram.html" title="Direct3D implementation of low-level fragment programs.">D3D11GpuFragmentProgram</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1D3D11GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D11GpuProgram</a>
<a name="l00076"></a>00076     {
<a name="l00077"></a>00077     <span class="keyword">protected</span>:
<a name="l00078"></a><a class="code" href="classOgre_1_1D3D11GpuFragmentProgram.html#a32752d560b3ac0116e255f8c537e98bb">00078</a>         ID3D11PixelShader * <a class="code" href="classOgre_1_1D3D11GpuFragmentProgram.html#a32752d560b3ac0116e255f8c537e98bb">mPixelShader</a>;
<a name="l00079"></a>00079     <span class="keyword">public</span>:
<a name="l00080"></a>00080         <a class="code" href="classOgre_1_1D3D11GpuFragmentProgram.html#a95acdb9a7172ed6f3be6b38daf9c072a">D3D11GpuFragmentProgram</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00081"></a>00081             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader, <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; device);
<a name="l00082"></a>00082         <a class="code" href="classOgre_1_1D3D11GpuFragmentProgram.html#af0fd6e6680bacf8f182c48ad716e1644">~D3D11GpuFragmentProgram</a>();
<a name="l00084"></a>00084         ID3D11PixelShader * <a class="code" href="classOgre_1_1D3D11GpuFragmentProgram.html#abd83246241900f4800984bc8e74f1e67" title="Gets the pixel shader.">getPixelShader</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00085"></a>00085     <span class="keyword">protected</span>:
<a name="l00087"></a>00087         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11GpuFragmentProgram.html#adef7da172c30120d43c1ba51c35ad50c">unloadImpl</a>(<span class="keywordtype">void</span>);
<a name="l00088"></a>00088         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11GpuFragmentProgram.html#a158de30c66a1e14ecf9a618ca262d38e" title="Internal method to load from microcode, must be overridden by subclasses.">loadFromMicrocode</a>(ID3D10Blob *  microcode);
<a name="l00089"></a>00089     };
<a name="l00096"></a><a class="code" href="classOgre_1_1D3D11GpuProgramPtr.html">00096</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1D3D11GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D11GpuProgramPtr.">D3D11GpuProgramPtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;D3D11GpuProgram&gt; 
<a name="l00097"></a>00097     {
<a name="l00098"></a>00098     <span class="keyword">public</span>:
<a name="l00099"></a><a class="code" href="classOgre_1_1D3D11GpuProgramPtr.html#a4f614023e7b8343643c2d59f9bb83834">00099</a>         <a class="code" href="classOgre_1_1D3D11GpuProgramPtr.html#a4f614023e7b8343643c2d59f9bb83834">D3D11GpuProgramPtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D11GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D11GpuProgram</a>&gt;() {}
<a name="l00100"></a><a class="code" href="classOgre_1_1D3D11GpuProgramPtr.html#a333de235effb008c32d43ba7882dc634">00100</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1D3D11GpuProgramPtr.html#a333de235effb008c32d43ba7882dc634">D3D11GpuProgramPtr</a>(<a class="code" href="classOgre_1_1D3D11GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D11GpuProgram</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D11GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D11GpuProgram</a>&gt;(rep) {}
<a name="l00101"></a><a class="code" href="classOgre_1_1D3D11GpuProgramPtr.html#a2ded5520e4e8b5ffef87eb3acb46da51">00101</a>         <a class="code" href="classOgre_1_1D3D11GpuProgramPtr.html#a2ded5520e4e8b5ffef87eb3acb46da51">D3D11GpuProgramPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1D3D11GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D11GpuProgramPtr.">D3D11GpuProgramPtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D11GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D11GpuProgram</a>&gt;(r) {} 
<a name="l00102"></a><a class="code" href="classOgre_1_1D3D11GpuProgramPtr.html#a75c87514e4c3f48585406b93acf84d26">00102</a>         <a class="code" href="classOgre_1_1D3D11GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D11GpuProgramPtr.">D3D11GpuProgramPtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1D3D11GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D11GpuProgram</a>&gt;()
<a name="l00103"></a>00103         {
<a name="l00104"></a>00104             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00105"></a>00105             <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00106"></a>00106                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00107"></a>00107                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1D3D11GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D11GpuProgram</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00108"></a>00108             pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00109"></a>00109             <span class="keywordflow">if</span> (pUseCount)
<a name="l00110"></a>00110             {
<a name="l00111"></a>00111                 ++(*pUseCount);
<a name="l00112"></a>00112             }
<a name="l00113"></a>00113         }
<a name="l00114"></a>00114 
<a name="l00116"></a><a class="code" href="classOgre_1_1D3D11GpuProgramPtr.html#aab2bc3329328b67aacac1429b5874a7b">00116</a>         <a class="code" href="classOgre_1_1D3D11GpuProgramPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to D3D11GpuProgramPtr.">D3D11GpuProgramPtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r)
<a name="l00117"></a>00117         {
<a name="l00118"></a>00118             <span class="keywordflow">if</span> (pRep == static_cast&lt;D3D11GpuProgram*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00119"></a>00119                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00120"></a>00120             release();
<a name="l00121"></a>00121             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00122"></a>00122             <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00123"></a>00123                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00124"></a>00124                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1D3D11GpuProgram.html" title="Direct3D implementation of a few things common to low-level vertex &amp; fragment programs.">D3D11GpuProgram</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00125"></a>00125             pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00126"></a>00126             <span class="keywordflow">if</span> (pUseCount)
<a name="l00127"></a>00127             {
<a name="l00128"></a>00128                 ++(*pUseCount);
<a name="l00129"></a>00129             }
<a name="l00130"></a>00130             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00131"></a>00131         }
<a name="l00132"></a>00132     };
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 }
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
